{ CD Player. ()  .., 2003}
unit CDp2_;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, MPlayer, ExtCtrls,
  MMSYSTEM;

type
  TForm1 = class(TForm)
    MediaPlayer: TMediaPlayer;
    TrackBar: TTrackBar;
    Button1: TButton;
    Timer1: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    procedure TrackBarChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  Track: integer;

//    
procedure TForm1.TrackBarChange(Sender: TObject);
var
  trk: integer; // ,   
begin
  trk :=TrackBar.Position;
  if trk > MCI_TMSF_TRACK(MediaPlayer.Position) then
    while trk > MCI_TMSF_TRACK(MediaPlayer.Position) do
      MediaPlayer.Next
  else
     while trk < MCI_TMSF_TRACK(MediaPlayer.Position) do
      MediaPlayer.Previous;
end;

//  Play/Stop
procedure TForm1.Button1Click(Sender: TObject);
begin
  if Button1.Tag = 0 then
    begin
      Button1.Caption := 'Stop';
      Button1.Tag :=1;
      MediaPlayer.Play;
    end
  else
    begin
      Button1.Caption := 'Play';
      Button1.Tag :=0;
      MediaPlayer.Stop;
    end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  if (MediaPlayer.Mode = mpStopped) and
     (MediaPlayer.Tracks > 1)
  then begin
        Button1.Enabled := True;
        TrackBar.Max := MediaPlayer.Tracks;
      end
  else begin
        label1.Caption := '   Audio CD';
       end;
end;

//   
procedure TForm1.Timer1Timer(Sender: TObject);
var
  trk,            // 
  min, sec: byte; // 
begin
  case MediaPlayer.Mode of

    mpPlaying: //  
    begin
      min := MCI_TMSF_MINUTE(MediaPlayer.Position);
      sec := MCI_TMSF_SECOND(MediaPlayer.Position);
      Label2.Caption :=
        Format('%d:%.2d',[min,sec]);

     // ,    
     trk := MCI_TMSF_TRACK(MediaPlayer.Position);
     if trk <> Track then
     begin
       Track:= trk;
       TrackBar.Position := Track;
       Label1.Caption :=
        Format('Track %d.',[trk]);
     end;
    end;

    mpOpen: //       
    begin
      if Button1.Enabled then
      begin
        Label1.Caption :='   Audio CD';
        Label2.Caption :='';
        Button1.Enabled := False; //   
        Button1.Caption := 'Play';
      end;

      //  
      if Label1.Visible
        then Label1.Visible := False
        else Label1.Visible := True;

    end;

    mpStopped: //  
    begin
      if not Button1.Enabled
        then  begin
          //      
          //   
          MediaPlayer.Open;
          Button1.Enabled := True;
          Label1.Caption := 'Track: 1';
          Label1.Visible := True;
          Label2.Caption:= '';
          TrackBar.Position := 1;
          TrackBar.Max := MediaPlayer.Tracks;
        end;

      if Button1.Tag = 1 then
      begin
        //    
        Button1.Caption := 'Play';
        Button1.Tag :=0;
        TrackBar.Position := 1;
        Label1.Caption := 'Track 1';
        Label2.Caption := '';
      end;
    end;
   end; // case

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MediaPlayer.Stop;
end;

end.
