{  Audio CD.
  ()  .., 2003 }
unit CDp_;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, MPlayer, ExtCtrls, MMSYSTEM;

type
  TForm1 = class(TForm)
    MediaPlayer: TMediaPlayer;
    Timer1: TTimer;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Image1: TImage;
    procedure FormActivate(Sender: TObject);
    procedure MediaPlayerNotify(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  Track: integer; //  

//   
procedure TForm1.FormActivate(Sender: TObject);
begin
  MediaPlayer.Open;
  { ,   CD-ROM AudioCD.
        ,  
    Mode = mpStopped.   ,
      ,  Mode = mpOpen.
         
    .   - CD-ROM,    
    ,    -    1 }
  if (MediaPlayer.Mode = mpStopped) and
     (MediaPlayer.Tracks > 1) then
  begin
    BitBtn1.Enabled := True;
    MediaPlayer.Notify := True;
  end
  else Timer1.Enabled := True;
end;

//   MediaPlayer
procedure TForm1.MediaPlayerNotify(Sender: TObject);
begin
  case MediaPlayer.Mode of

  mpOpen: //   
    begin
        BitBtn1.Enabled := False;
        BitBtn1.Caption := 'Play';
        BitBtn1.Tag := 0;
        BitBtn2.Enabled := False;
        BitBtn3.Enabled := False;
        Timer1.Enabled := True;
        Label2.Caption := '00:00';
    end;

  end;
  MediaPlayer.Notify := True;
end;

//    Play/Stop
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  if BitBtn1.Tag = 0
  then //    Play
  begin
    BitBtn1.Caption := 'Stop';
    BitBtn3.Enabled := True;
    MediaPlayer.Notify := False;
    MediaPlayer.Play;
    Timer1.Enabled :=True;
    BitBtn1.Tag := 1;
    Track := MCI_TMSF_TRACK(MediaPlayer.Position);
  end
  else
  begin //    Stop
    BitBtn1.Caption := 'Play';
    BitBtn3.Enabled := True;
    MediaPlayer.Notify := True;
    MediaPlayer.Stop;
    Timer1.Enabled := False;
    BitBtn1.Tag := 0;
   end;
end;

//   :    
//  
procedure TForm1.Timer1Timer(Sender: TObject);
var
  trk,            // 
  min, sec: byte; // 
begin

  if MediaPlayer.Mode = mpPlaying then
  //  
  begin
    trk := MCI_TMSF_TRACK(MediaPlayer.Position);
    min := MCI_TMSF_MINUTE(MediaPlayer.Position);
    sec := MCI_TMSF_SECOND(MediaPlayer.Position);
    Label1.Caption :=
        Format('Track %d.',[trk]);
    Label2.Caption :=
        Format('%d:%.2d',[min,sec]);

    if trk <> Track then
    begin
      Track := trk;
      if Track = 2
        then BitBtn2.Enabled := True;
      if Track = MediaPlayer.Tracks
        then BitBtn3.Enabled := False;
    end;
    exit;
  end;

  //       
  // AudioCD,  Mode = mpOpen
  //   ( mpStopped + -  > 1)
  if (MediaPlayer.Mode = mpStopped) and
     (MediaPlayer.Tracks > 1) then
  begin
    Timer1.Enabled := False;
    MediaPlayer.Open;
    BitBtn1.Enabled := True;
    MediaPlayer.Notify := True;
    Label1.Caption := 'Audio CD';
    Label1.Visible := True;
  end;

  //       
  if MediaPlayer.Mode = mpOpen then
  begin
    Label1.Caption := ' Audio CD';
    if Label1.Visible then
      Label1.Visible := False
    else
      Label1.Visible := True;
  end;
end;

//  <<
procedure TForm1.BitBtn2Click(Sender: TObject);
begin
    MediaPlayer.Previous; //    
    MediaPlayer.Previous; //    
    if MCI_TMSF_TRACK(MediaPlayer.Position) = 1 then
      BitBtn2.Enabled := False;
    if not BitBtn3.Enabled
      then BitBtn3.Enabled := True;
end;

//  >>
procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  MediaPlayer.Next;
  //     ,  
  // Next  
  if MCI_TMSF_TRACK(MediaPlayer.Position) = MediaPlayer.Tracks
    then BitBtn3.Enabled := False;
end;

//    
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MediaPlayer.Stop;
end;

end.
